#include "parser.h"

symbol_t* symbol_new (gboolean terminal, gint value)
{
  symbol_t* symbol;
  symbol = g_malloc (sizeof (symbol_t));
  symbol->terminal = terminal;
  symbol->value = value;
  return symbol;
}

rule_t* rule_new (symbol_t* left)
{
  rule_t* rule;
  rule = g_malloc (sizeof (rule_t));
  rule->left = left;
  rule->right = NULL;
  return rule;
}

void rule_append (rule_t* rule, symbol_t* right)
{
  rule->right = g_list_append (rule->right, right);
}

guint symbol_hash (gconstpointer data)
{
  symbol_t* symbol;
  symbol = (symbol_t*) data;
  return g_direct_hash (symbol->value);
}

gboolean symbol_equal (gconstpointer data1, gconstpointer data2)
{
  symbol_t* symbol1;
  symbol_t* symbol2;
  symbol1 = (symbol_t*) data1;
  symbol2 = (symbol_t*) data2;
  return symbol1->value == symbol2->value &&
    symbol1->terminal == symbol2->terminal;
}

